package payment;


import org.apache.commons.codec.digest.DigestUtils;
import util.FastJsonUtil;
import util.RSA2Encript;
import util.RsaUtil;
import util.StringUtil;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;


/*
模拟回调接口，供参考
 */
public class CALLBACK {


	public String ReturnUrl(HttpServletRequest request, HttpServletResponse response) throws Exception{

		/*
		form表单POST方式回调，通过request.getParameter("") 获取参数结果
		以下为模拟后台接收，仅供参考
		 */
		String key = "1d1edbb806e94a066f2fd1e68a659f53";
		String publicpath = System.getProperty("user.dir")+"/MANDAO_814000473149_pub.cer";
		log("公钥路径:"+publicpath);
		String method = request.getParameter("method");
		String version = request.getParameter("version");
		String format = request.getParameter("format");
		String merchantNo =request.getParameter("merchantNo");
		String signType = request.getParameter("signType");
		String signContent =request.getParameter("signContent");
		String sign =request.getParameter("sign");

        /**
         * rsa 响应报文验签流程，当signType为RSA2时
         * 1.全报文除sig外按照固定格式拼接生成待加密串
         * 2.RSA验签
	     * */


		String signStr= StringUtil.reqSingStr(method,version,format,merchantNo,signType,signContent,key);

		log("[回调]固定格式拼接后明文："+signStr);


		boolean verifyResult = RSA2Encript.verify(signStr,sign,publicpath);
		if(verifyResult){
			log("验签通过");

		}
		else{
			log("验签失败");
		}
		return "SUCCESS";
}
	private static void log(String msg) {
		System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) + ":\t " + msg);
	}
}

