package payment;

import util.*;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


/*
微信公众号、支付宝生活号、银联JSAPI下单接口
 */
public class JSAPI_PAYMENT {


	public  static void main(String[] args) throws Exception {
		String pfxpath= System.getProperty("user.dir")+"/814000473149_pri.pfx";
		log("私钥路径:"+pfxpath);
		String pwd = "123456";
		String publicpath = System.getProperty("user.dir")+"/MANDAO_814000473149_pub.cer";
		log("公钥路径:"+publicpath);
		String key = "1d1edbb806e94a066f2fd1e68a659f53";
		String url = "https://test-api.huishouqian.com/api/acquiring";

		/**
		 公共请求参数
		 */

		Map<String,Object> params = new HashMap();
		// 请求方法
		String method = "POLYMERIZE_MAIN_SWEPTN";
		params.put("method",method);
		// 版本
		String version = "1.0";
		params.put("version",version);
		// 请求格式
		String format = "JSON";
		params.put("format",format);
		//商户号
		String merchantNo = "814000473149";
		params.put("merchantNo",merchantNo);
		//加密方式
		String signType = "RSA2";
		params.put("signType",signType);
		//加密数据
		String signContent = "";
		params.put("signContent",signContent);
		//签名数据
		String sign = "";
		params.put("sign",sign);


		/**
		 * 业务请求参数
		 */
		Map<String,Object> body = new HashMap();
//		//门店编号
//		String subMerchantNo = "";
//		body.put("subMerchantNo",subMerchantNo);
		//商户订单号
		String transNo = "DD" + new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date());
		body.put("transNo",transNo);
		//支付类型
		String payType = "WECHAT_JSAPI";
		body.put("payType",payType);
		//交易金额
		String orderAmt = "1";
		body.put("orderAmt",orderAmt);
		//商品信息摘要
		String goodsInfo = "测试";
		body.put("goodsInfo",goodsInfo);
		//前台跳转地址
		String pageUrl = "";
		body.put("pageUrl",pageUrl);
		//后台回调地址
		String returnUrl = "";
		body.put("returnUrl",returnUrl);
		//请求时间
		String requestDate = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
		body.put("requestDate",requestDate);
		//原样返回字段
		String extend = "自定义字段";
		body.put("extend",extend);
		//扩展字段
		String memo = "";
		body.put("memo",memo);


		Map<String,String> extendmemo = new HashMap<String,String>();
		//限制卡类型
		String paylimit = "balance";
		extendmemo.put("paylimit",paylimit);

		//交易结束时间
		String timeExpire =  "";
		extendmemo.put("timeExpire",timeExpire);
		//用户ID
		String openid = "oUpF8uMuAJO_M2pxb1Q9zNjWeS6o";
		extendmemo.put("openid",openid);
		extendmemo.put("openid","2088302324135742");
		//appid
		String appid = "wxb63c89abb9243ad0";
		extendmemo.put("appid",appid);
		extendmemo.put("appid","2021001155671536");
		//分账域，分账时必填
//		String shareInfo = "100000178,1";
//		extendmemo.put("shareInfo",shareInfo);
		//终端用户IP
		String spbillCreateIp = "172.22.11.2";
		extendmemo.put("spbillCreateIp",spbillCreateIp);
		//经度
		String longitude = "116.397128";
		extendmemo.put("longitude",longitude);
		//纬度
		String latitude = "39.916527";
		extendmemo.put("latitude",latitude);
		//以下银联需要上送
		extendmemo.put("areaInfo","");
		extendmemo.put("appVersion","");
		extendmemo.put("deviceType","");
		extendmemo.put("deviceNo","");

		log("memo:"+extendmemo.toString());

		body.put("memo", FastJsonUtil.collectToString(extendmemo));

		signContent = FastJsonUtil.collectToString(body);
		log("[请求]业务请求参数："+signContent);
		params.put("signContent",signContent);

		/**
		 * rsa 验签算法流程，当signType为RSA2时
		 * 1.先按固定格式拼接
		 * 2.RSA签名
		 */
		String signStr= StringUtil.reqSingStr(method,version,format,merchantNo,signType,signContent,key);
		log("[请求]固定格式拼接后明文："+signStr);
		sign = RSA2Encript.sign(signStr,pfxpath,pwd);
		log("[请求]RSA加签后内容："+sign);
		params.put("sign",sign);


		log("[请求] 请求内容："+ params.toString());
		String resp = HttpUtil.RequestForm(url,params);
		log("响应] 响应内容："+resp);
		Map<String,Object> respMap = (Map<String, Object>) FastJsonUtil.convertJsonToObject(resp,Map.class);

		/**
		 * rsa 响应报文验签流程，当signType为RSA2时
		 * 1.全报文除sig外按照固定格式拼接生成待加密串
		 * 2.RSA验签
		 */
		String respSign =StringUtil.resSingStr(respMap,key);
		log("[响应] 固定格式拼接后："+respSign);
		boolean verifyResult = RSA2Encript.verify(respSign,respMap.get("sign").toString(),publicpath);
		if(verifyResult){
			log("验签通过");
			String resResult =  respMap.get("result").toString();
			Map<String,Object> result = (Map<String, Object>) FastJsonUtil.convertJsonToObject(resResult,Map.class);
			if(result.get("orderStatus").toString().equals("SUCCESS")){
				log("[交易结果]交易成功，成功金额："+result.get("orderAmt").toString()+"分。");
			}
			else {
				log("[交易结果]交易未成功,"+result.get("respMsg").toString());
			}
		}
		else{
			log("验签失败");
		}

	}
	private static void log(String msg) {
		System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) + ":\t " + msg);
	}

}
