package payment;


import org.apache.commons.codec.digest.DigestUtils;
import util.RSA2Encript;
import util.RsaUtil;
import util.StringUtil;
import java.text.SimpleDateFormat;
import java.util.Date;

/*
测试RSA加解密
 */
public class RSA_TEST {

	public static void main(String[] args) throws Exception {
		resRsaSign();
//		reqRsaSign();

	}

	//测试证书加密
	public static void encrypt() throws Exception{

		String pfxpath= System.getProperty("user.dir")+"/814000473149_pri.pfx";
		String pwd = "123456";
		String orginData = "测试加密数据";
		//加密
		//1、BASE64加密
		String base64EncodeData = RsaUtil.base64Encode(orginData);
		log("[请求-加密-BASE64加密] BASE64加密内容：" + base64EncodeData);
		//2、私钥加密
		String rsaEncryptData = RsaUtil.encryptByPriPfxFile(base64EncodeData, pfxpath, pwd);
		log("[请求-加密-私钥加密] 私钥加密内容：" + rsaEncryptData);
	}

	//测试证书解密
	public static void decrypt() throws Exception{
		String publicpath = System.getProperty("user.dir")+"/814000473149_pub.cer";
		String rsaEncryptData = "a42716474a48aee656f0ccb43c91876dd7adb50823d5933f10ee8c174bb29a8fe72e62e6da2c967cec16172293d132bd25cf0c2451c7a46155f008b625384ccc1f0d66d995e9546acc8d4aa632f4c93faabf865d561b042af0cc9aaffed36a9606f48f9e1d92b88abe9a2a7121bbf683331dc063b35f58c31173a2efd73bdf20";
		//1、公钥解密
		String decrypt = RsaUtil.decryptByPubCerFile(rsaEncryptData, publicpath);
		log("[响应-解密-公钥解密] 私钥加密内容："+ decrypt);
		//2、BASE64解密
		decrypt = RsaUtil.base64Decode(decrypt);
		log("[响应-解密-BASE64解密] BASE64解密内容："+ decrypt);
	}

	//测试ras2加签
	public static void reqRsaSign() throws Exception{
		String pfxpath= System.getProperty("user.dir")+"/814000473149_pri.pfx";
		String pwd = "123456";
		String signStr = "method=POLYMERIZE_QUERY&version=1.0&format=json&merchantNo=814000473149&signType=RSA&signContent={\"transNo\":\"DD20210817152647231\",\"queryType\":\"2\"}&key=86a8eec5ae958e9948b7450439cc57e2";
		String sign = RSA2Encript.sign(signStr,pfxpath,pwd);
		log("[请求]RSA加签后内容："+sign);

	}

	//测试ras2验签
	public static void resRsaSign() {
		String publicpath = System.getProperty("user.dir")+"/MANDAO_814000473149_pub.cer";
		String sign ="11e6c50d60ebdeacfe5d55dad1a0c11925b0850602d42346d1824e1e97d1581f4b21b258962a2289842a8c75d6af7c687a30d25af64ad467a2f050311e90149aee5fd60868b85dfeb3e2ac8d52509fc4a75c57c33ca8f511e0afdd92d5f025a2e70bc86d0f678019a3a040862defcb3e54c327a452ad623a9d88eec71b996cbb";
		String respSign ="result={\"orderStatus\":\"FAIL\",\"respCode\":\"200004\",\"respMsg\":\"订单不存在\"}&success=true&key=86a8eec5ae958e9948b7450439cc57e2";
		boolean verifyResult = RSA2Encript.verify(respSign,sign,publicpath);
		if(verifyResult) {
			log("验签通过");
		}

	}

	private static void log(String msg) {
		System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) + ":\t " + msg);
	}
}

