package payment;

import util.*;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;


/*
交易退款接口
 */
public class TRANS_REFUND {


	public  static void main(String[] args) throws Exception {

		String pfxpath= System.getProperty("user.dir")+"/814000473149_pri.pfx";
		log("私钥路径:"+pfxpath);
		String pwd = "123456";
		String publicpath = System.getProperty("user.dir")+"/MANDAO_814000473149_pub.cer";
		log("公钥路径:"+publicpath);
		String key = "1d1edbb806e94a066f2fd1e68a659f53";
		String url = "https://test-api.huishouqian.com/api/acquiring";

		/**
		 公共请求参数
		 */

		Map<String,Object> params = new HashMap();
		// 请求方法
		String method = "POLYMERIZE_REFUND";
		params.put("method",method);
		// 版本
		String version = "1.0";
		params.put("version",version);
		// 请求格式
		String format = "JSON";
		params.put("format",format);
		//商户号
		String merchantNo = "814000473149";
		params.put("merchantNo",merchantNo);
		//加密方式
		String signType = "RSA2";
		params.put("signType",signType);
		//加密数据
		String signContent = "";
		params.put("signContent",signContent);
		//签名数据
		String sign = "";
		params.put("sign",sign);


		/**
		 * 业务请求参数
		 */
		Map<String,Object> body = new HashMap();

		//商户订单号
		String transNo = "DD" + new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date());
		body.put("transNo",transNo);
		//退款类型
		String refundType = "1";
		body.put("refundType",refundType);
		//原商户订单号
		String origTransNo = "DD202108121025550291";
		body.put("origTransNo",origTransNo);
		//原交易金额
		String origOrderAmt = "1";
		body.put("origOrderAmt",origOrderAmt);
		//退款金额
		String orderAmt	= "1";
		body.put("orderAmt",orderAmt);
		//交易日期
		String requestDate = new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
		body.put("requestDate",requestDate);
		//退款原因
		String refundReason	 = "测试";
		body.put("refundReason",refundReason);
		//回调地址
		String returnUrl = "https://www.merchant.com";
		body.put("returnUrl",returnUrl);
		//扩展字段
		String extend	= "自定义参数";
		body.put("extend",extend);

		signContent = FastJsonUtil.collectToString(body);
		log("[请求]业务请求参数："+signContent);
		params.put("signContent",signContent);

		/**
		 * rsa 验签算法流程，当signType为RSA2时
		 * 1.先按固定格式拼接
		 * 2.RSA签名
		 */
		String signStr= StringUtil.reqSingStr(method,version,format,merchantNo,signType,signContent,key);
		log("[请求]固定格式拼接后明文："+signStr);
		sign = RSA2Encript.sign(signStr,pfxpath,pwd);
		log("[请求]RSA加签后内容："+sign);
		params.put("sign",sign);


		log("[请求] 请求内容："+ params.toString());
		String resp = HttpUtil.RequestForm(url,params);
		log("响应] 响应内容："+resp);
		Map<String,Object> respMap = (Map<String, Object>) FastJsonUtil.convertJsonToObject(resp,Map.class);

		/**
		 * rsa 响应报文验签流程，当signType为RSA2时
		 * 1.全报文除sig外按照固定格式拼接生成待加密串
		 * 2.RSA验签
		 */
		String respSign =StringUtil.resSingStr(respMap,key);
		log("[响应] 固定格式拼接后："+respSign);
		boolean verifyResult = RSA2Encript.verify(respSign,respMap.get("sign").toString(),publicpath);
		if(verifyResult){
			log("验签通过");
			String resResult =  respMap.get("result").toString();
			Map<String,Object> result = (Map<String, Object>) FastJsonUtil.convertJsonToObject(resResult,Map.class);
			if(result.get("orderStatus").toString().equals("SUCCESS")){
				log("[交易结果]交易成功，成功金额："+result.get("orderAmt").toString()+"分。");
			}
			else {
				log("[交易结果]交易未成功,"+result.get("respMsg").toString());
			}
		}
		else{
			log("验签失败");
		}


	}
	private static void log(String msg) {
		System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()) + ":\t " + msg);
	}

}
